module EventRegistryApi
  class Client

    SOURCES = [
      "concepts",
      "conceptClass",
      "conceptFolder",
      "loc"
    ]

    ##
    # The concepts api.
    #
    module Concepts

      ##
      # Get a list of concepts given a keyword prefix.
      # @param {String}
      # @param {Hash}
      # @return {Array}
      #
      def concepts (keyword, options={})
        options = {
          sources: SOURCES[0..2]
        }.merge(options)

        _get("/json/suggestConcepts", _concepts_query(keyword, options))
      end

      private

      ##
      # @param {String}
      # @param {Hash}
      # @return {Hash}
      #
      def _concepts_query (prefix, options)
        {
          "prefix" => prefix,
          "lang" => "eng",
          "fullLocInfo" => true,
          "source" => options[:sources]
        }
      end
    end
  end
end
